searchNodes=[{"doc":"Documentation for StatetraceElixir.","ref":"StatetraceElixir.html","title":"StatetraceElixir","type":"module"},{"doc":"Schema for annotating database transactions for Statetrace.Statetrace treats values written to statetrace_annotations in a special way, allowing you to annotate the row-level transaction information. This should not be used directly, instead you should use StatetraceElixir.AnnotationsFor information about integration see process_conn/2","ref":"StatetraceElixir.Annotations.html","title":"StatetraceElixir.Annotations","type":"module"},{"doc":"Annotate action information into the current database transaction.","ref":"StatetraceElixir.Annotations.html#log_action!/4","title":"StatetraceElixir.Annotations.log_action!/4","type":"function"},{"doc":"Annotate session information into the current database transaction.","ref":"StatetraceElixir.Annotations.html#log_session!/4","title":"StatetraceElixir.Annotations.log_session!/4","type":"function"},{"doc":"Generate the numerical portion of the frame's ID.","ref":"StatetraceElixir.Annotations.html#new_id/0","title":"StatetraceElixir.Annotations.new_id/0","type":"function"},{"doc":"Annotates action information as part of process_conn/2 This function is exposed to give finer grained control over those who need it. In general it is recommended to use process_conn/2","ref":"StatetraceElixir.Annotations.html#process_action!/3","title":"StatetraceElixir.Annotations.process_action!/3","type":"function"},{"doc":"Processes a Plug.Conn to annotate the current transaction with request details.This should be called inside of a transaction for example: defmodule MyAppWeb.SomeController do use MyAppWeb, :controller alias StatetraceElixir.Annotations def action(conn, _) do args = [conn, conn.params] with {_, response} &lt;- MyApp.Repo.transaction(fn -&gt; Annotations.process_conn(conn, get_actor: fn conn -&gt; conn.assigns.current_actor end, repo: MyApp.Repo ) apply(__MODULE__, action_name(conn), args) end) do response end end end","ref":"StatetraceElixir.Annotations.html#process_conn/2","title":"StatetraceElixir.Annotations.process_conn/2","type":"function"},{"doc":"Annotates session information as part of process_conn/2 This function is exposed to give finer grained control over those who need it. In general it is recommended to use process_conn/2","ref":"StatetraceElixir.Annotations.html#process_session!/3","title":"StatetraceElixir.Annotations.process_session!/3","type":"function"},{"doc":"Schema for annotating database transactions for Statetrace.Statetrace treats values written to statetrace_annotations in a special way, allowing you to annotate the row-level transaction information. This should not be used directly, instead you should use StatetraceElixir.Annotations","ref":"StatetraceElixir.Annotations.Annotation.html","title":"StatetraceElixir.Annotations.Annotation","type":"module"},{"doc":"","ref":"StatetraceElixir.Annotations.CurrentUser.html","title":"StatetraceElixir.Annotations.CurrentUser","type":"module"},{"doc":"StatetraceElixirElixir integration for https://www.statetrace.com","ref":"readme.html","title":"StatetraceElixir","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding statetrace_elixir to your list of dependencies in mix.exs:def deps do [ {:statetrace_elixir, &quot;~&gt; 0.1.0&quot;} ] endAfter the packages are installed you must create a database migration to add the statetrace_annotations table to your database:mix ecto.gen.migration add_statetrace_annotations_tableOpen the generated migration in your editor and call the up and down functions on StatetraceElixir.Migrations:defmodule MyApp.Repo.Migrations.AddStatetraceAnnotationsTable do use Ecto.Migration def up do StatetraceElixir.Migrations.up() end # We specify `version: 1` in `down`, ensuring that we&#39;ll roll all the way back down if # necessary, regardless of which version we&#39;ve migrated `up` to. def down do StatetraceElixir.Migrations.down(version: 1) end endNew versions may require additional migrations, however, migrations will never change between versions and they are always idempotent.Now, run the migration to create the table:mix ecto.migrateNext we need to annotate your http requests' transactions. Wrap &amp;action/2 in your controllers in a transaction and annotate it.Its easiest to add this to &lt;YourProject&gt;Webdefmodule &lt;YourProject&gt;Web do def controller do quote do use Phoenix.Controller, namespace: &lt;YourProject&gt;Web import Plug.Conn import &lt;YourProject&gt;Web.Gettext alias &lt;YourProject&gt;Web.Router.Helpers, as: Routes defp current_actor(conn) do conn.assigns.current_user # Should return %{id: String.t | nil, full_name: String.t | nil, avatar: String.t | nil} end def action(conn, _) do args = [conn, conn.params] with {_, response} &lt;- &lt;YourProject&gt;.Repo.transaction(fn -&gt; StatetraceElixir.Annotations.process_conn(conn, get_actor: &amp;current_actor/1, repo: &lt;YourProject&gt;.Repo ) apply(__MODULE__, action_name(conn), args) end) do response end end end end endDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/statetrace_elixir.","ref":"readme.html#installation","title":"StatetraceElixir - Installation","type":"extras"}]